#include <stdio.h>
#include <stdlib.h>

typedef struct
{
	int w;	//image width
	int h;	//image height
	int *p; //image pixels
} image;


// The function that reads in the PGM-file
void image_reader(const char *filename, image *img)
{
	FILE *file = fopen(filename, "r");
	if(file == NULL)
	{
		perror("ERROR MESSAGE");
		exit(EXIT_FAILURE);
	}
	//reads the PMG-header
	fscanf(file, "P2 %d %d 255", &img->w, &img->h);
	//allocates the memory for the pixeldata
	img -> p = (int *)malloc(img ->w * img ->h * sizeof(int));
	//reads the pixelvaleus
	for(int i = 0; i < img -> w * img ->h; i++)
	{
		fscanf(file,"%d",&img->p[i]);
	}
	
	fclose(file);
}

int main(int argc, char *argv[])
{
if(argc !=2){
	printf("Invalid input");
	return EXIT_FAILURE;
	}	
	
	image img;
	//reads the image 
	image_reader(argv[1],&img);
	// writrd out the fist and last pixel value
	printf("%d %d\n", img.p[0], img.p[img.w *img.h - 1]);
	
	//frees the allocated memory 
	free(img.p);
	
	return EXIT_SUCCESS;
}
